#include <Wire.h>
#include <math.h>
#include <L3G.h>
#include <LSM303.h>
#include <EEPROM.h>
#include "Timer.h"

L3G gyro;
LSM303 compass;
Timer t;

String pttr = "";
String gga = "";
char c1, c2;
int new_msg = 0, new_gga = 0, k, i, j, isupdate;
unsigned char xili;
int zar = 0, p_c;
char lat[15], lon[15], time[15], hdop[6], N, E, T, hd;
double x_min = 10000, x_max = -10000, y_min = 10000, y_max = -10000, z_min = 10000, z_max = -10000, x[5], xy[5], xz[5], zz[5], y[5], z[5], yyy[5], temp, x_0, y_0, z_0, modul, mm, mmm;
double x_mag, y_mag, z_mag, x_mag_m, y_mag_m, z_mag_m, x_acc, y_acc, z_acc, x_gyr, y_gyr, z_gyr;
double x_y, x_z;
double roll, pitch, hx, hy, yaw;
double xrp[2][1], xrp_[2][1], Frp[2][2], EKF2[2][2], EKF1[2][1], Prp[2][2] = {0, 0, 0, 0}, Prp_[2][2], Qrp[2][2] = {0.1, 0, 0, 0.1}, yrp[2][1], Hrp[2][2] = {1, 0, 0, 1}, Srp[2][2], Rrp[2][2] = {1, 0, 0, 1}, Krp[2][2], Irp[2][2] = {1, 0, 0, 1};
double XY, Ry, xy_, Fy, Py_, Py = 0, Qy = 0.1, yy, Sy, Hy = 1, Ky, Iy = 1;
double tm, lt, ln, h;
unsigned char *chptr;
unsigned char Xor = 0, cal = 0;

void setup() {
	Serial1.begin(115200);
	Serial2.begin(115200);
	Wire.begin();
        
	pinMode(8, INPUT);
        
	compass.init();
	gyro.init();
	compass.enableDefault();
	gyro.enableDefault();
  
	t.every(100, imu);
  
	pttr.reserve(100);
	gga.reserve(100);

	x_0 = EEPROM.read(1) * 256;
	x_0 += EEPROM.read(2);
	y_0 = EEPROM.read(3) * 256;
	y_0 += EEPROM.read(4);
	z_0 = EEPROM.read(5) * 256;
	z_0 += EEPROM.read(6);
	x_max = EEPROM.read(7) * 256;
	x_max += EEPROM.read(8);
	y_max = EEPROM.read(9) * 256;
	y_max += EEPROM.read(10);
	z_max = EEPROM.read(11) * 256;
	z_max += EEPROM.read(12);
	modul = EEPROM.read(13) * 256;
	modul += EEPROM.read(14);

	x_0 /= 1000;
	y_0 /= 1000;
	z_0 /= 1000;
	x_max /= 1000;
	y_max /= 1000;
	z_max /= 1000;
	modul /= 1000;

	x_y = (x_max - x_0) / (y_max - y_0);
	x_z = (x_max - x_0) / (z_max - z_0);

	Serial1.print("\r\n");
	Serial1.print(x_0,3);
	Serial1.print("\r\n");
	Serial1.print(y_0,3);
	Serial1.print("\r\n");
	Serial1.print(z_0,3);
	Serial1.print("\r\n");
	Serial1.print(x_y,3);
	Serial1.print("\r\n");
	Serial1.print(x_z,3);
	Serial1.print("\r\n");
	Serial1.print(x_max,3);
	Serial1.print("\r\n");
	Serial1.print(y_max,3);
	Serial1.print("\r\n");
	Serial1.print(z_max,3);
	Serial1.print("\r\n");
	Serial1.print(modul,3);
	Serial1.print("\r\n");

	compass.read();
	
	x_acc = (int)compass.a.x;
	y_acc = (int)compass.a.y;
	z_acc = (int)compass.a.z;
	
	x_mag = (int)compass.m.x;
	y_mag = (int)compass.m.y;
	z_mag = (int)compass.m.z;
	
	x_mag /= 1055;
	y_mag /= 950;
	z_mag /= 1055;
	x_mag -= x_0;
	y_mag -= y_0;
	z_mag -= z_0;
	y_mag *= x_y;
	z_mag *= x_z;

	x_acc /= -16384;
	y_acc /= -16384;
	z_acc /= -16384;
	
	Serial1.print(x_mag,3);
	Serial1.print(y_mag,3);
	Serial1.print(z_mag,3);
	roll = atan2(y_acc, z_acc);
	pitch = atan2(x_acc, sqrt(y_acc * y_acc + z_acc * z_acc));
	pitch *= (-1);
	
	Serial1.print(roll,3);
	Serial1.print(pitch,3);
	
	hx = x_mag*cos(pitch)+y_mag*sin(pitch)*sin(roll)+z_mag*cos(roll)*sin(pitch);
	hy = y_mag*cos(roll)-z_mag*sin(roll);
	yaw = atan2(-hy, hx);

	xrp[0][0] = roll;
	xrp[1][0] = pitch;
	XY = yaw;
}

void loop() {
	if(new_gga){
		p_c = 0;
		zar = 0;
		N = 1;
		E = 1;
		T = 0;
		hd = 0;
		do {
			if (zar == 1)
				time[T++] = gga[p_c];
			if (zar == 2)
				lat[N++] = gga[p_c];
			if (zar == 3) {
				if (gga[p_c++] == 'N')
					lat[0] = '+';
				else
					lat[0] = '-';
			}
			if (zar == 4)
				lon[E++] = gga[p_c];
			if (zar == 5) {
				if (gga[p_c++] == 'E')
					lon[0] = '+';
				else
					lon[0] = '-';
			}
			if (zar == 8)
				hdop[hd++] = gga[p_c];
			if (gga[p_c] == ',')
				zar++;
			p_c++;
		}while(gga[p_c]);
		gga = "";
		new_gga = 0;
	}
	t.update();

	if (isupdate) {
		if (digitalRead(8))
			cal++;
		else
			cal = 0;
		if (cal == 10) {
			mag_cal();
			cal = 0;
		}
		
		x_mag = (int)compass.m.x;
		y_mag = (int)compass.m.y;
		z_mag = (int)compass.m.z;
		
		x_acc = (int)compass.a.x;
		y_acc = (int)compass.a.y;
		z_acc = (int)compass.a.z;
		
		x_gyr = (int)gyro.g.x;
		y_gyr = (int)gyro.g.y;
		z_gyr = (int)gyro.g.z;
		x_mag /= 1055;
		y_mag /= 950;
		z_mag /= 1055;
		x_mag -= x_0;
		y_mag -= y_0;
		z_mag -= z_0;
		y_mag *= x_y;
		z_mag *= x_z;
		
		x_acc /= -16384;
		y_acc /= -16384;
		z_acc /= -16384;

		mm = sqrt(x_mag*x_mag+y_mag*y_mag+z_mag*z_mag);
		
		x_gyr *= 0.00875 / 180 * M_PI;
		y_gyr *= 0.00875 / 180 * M_PI;
		z_gyr *= 0.00875 / 180 * M_PI;
		
		mmm = mm/modul;
		
		Ry = 10;
		if (mmm < 0.98 || mmm > 1.02)
			Ry = 100;
		if (mmm < 0.93 || mmm > 1.07)
			Ry = 500000;

		roll = atan2(y_acc, z_acc);
		pitch = atan2(x_acc, sqrt(y_acc * y_acc + z_acc * z_acc));
		pitch *= (-1);

		xrp_[0][0] = xrp[0][0] + (x_gyr + y_gyr*sin(xrp[0][0])*tan(xrp[1][0]) + z_gyr*cos(xrp[0][0])*tan(xrp[1][0]))*0.1;
		xrp_[1][0] = xrp[1][0] + (y_gyr*cos(xrp[0][0]) - z_gyr*sin(xrp[0][0]))*0.1;
		xy_ = XY + (y_gyr*sin(xrp[0][0])/cos(xrp[1][0]) + z_gyr*cos(xrp[0][0])/cos(xrp[1][0]))*0.1;

		Frp[0][0] = 1 + (tan(xrp[1][0])*(y_gyr*cos(xrp[0][0]) - z_gyr*sin(xrp[0][0]))*0.1);
		Frp[0][1] = (y_gyr*sin(xrp[0][0]) + z_gyr*cos(xrp[0][0]))*0.1/cos(xrp[1][0])/cos(xrp[1][0]);
		Frp[1][0] = -(y_gyr*sin(xrp[0][0]) + z_gyr*cos(xrp[0][0]))*0.1;
		Frp[1][1] = 1;

		t2x2(Frp, EKF2);
		m2x2(Prp, EKF2, Prp_);
		m2x2(Frp, Prp_, EKF2);
		s2x2(EKF2, Qrp, Prp_);

		yrp[0][0] = ((roll - xrp_[0][0]));
		yrp[1][0] = ((pitch - xrp_[1][0]));

		t2x2(Hrp,EKF2);
		m2x2(Prp_, EKF2, Srp);
		m2x2(Hrp, Srp, EKF2);
		s2x2(EKF2, Rrp, Srp);

		i2x2(Srp, Krp);
		m2x2(Hrp, Krp, EKF2);
		m2x2(Prp_, EKF2, Krp);

		m2x1(Krp, yrp, EKF1);
		s2x1(xrp_, EKF1, xrp);

		m2x2(Krp, Hrp, Prp);
		r2x2(Irp, Prp, EKF2);
		m2x2(EKF2, Prp_, Prp);

		Fy = 1;

		Py_ = Fy*Py*Fy + Qy;

		hx = x_mag * cos(xrp[1][0]) + y_mag * sin(xrp[1][0]) * sin(xrp[0][0])+ z_mag * cos(xrp[0][0]) * sin (xrp[1][0]);
		hy = y_mag * cos(xrp[0][0]) - z_mag * sin(xrp[0][0]);
		yaw = atan2(-hy,hx);

		yy = asin(sin(yaw-XY));

		Sy = Hy*Py_*Hy + Ry;

		Ky = Py_*Hy/Sy;

		XY = xy_ + Ky*yy;

		Py = (Iy - Ky*Hy)*Py_;
		Serial1.write(0xFF);
		Serial1.write(0xFF);
		Serial1.write(0xFF);
		Serial1.write(0xFF);
		
		time[T-1] = '\0';
		tm = atof(time);
		chptr = (unsigned char *) &tm;
		for(i=0; i<4;i++) {
			Xor ^= *chptr;
			Serial1.write(*chptr++);
		}
		time[0] = '\0';

		lat[N-1] = '\0';
		lt = atof(lat);
		chptr = (unsigned char *) &lt;
		for(i=0; i<4;i++) {
			Xor ^= *chptr;
			Serial1.write(*chptr++);
		}
		lat[0] = '\0';
		
		lon[E-1] = '\0';
		ln = atof(lon);
		chptr = (unsigned char *) &ln;
		for(i=0; i<4;i++) {
			Xor ^= *chptr;
			Serial1.write(*chptr++);
		}
		lon[0] = '\0';

		hdop[hd-1] = '\0';
		h = atof(hdop);
		chptr = (unsigned char *) &h;
		for(i=0; i<4;i++) {
			Xor ^= *chptr;
			Serial1.write(*chptr++);
		}
		hdop[0] = '\0';

		chptr = (unsigned char *) &x_acc;
		for(i=0; i<4;i++) {
			Xor ^= *chptr;
			Serial1.write(*chptr++);
		}
		
		chptr = (unsigned char *) &y_acc;
		for(i=0; i<4;i++) {
			Xor ^= *chptr;
			Serial1.write(*chptr++);
		}
		
		chptr = (unsigned char *) &z_acc;
		for(i=0; i<4;i++) {
			Xor ^= *chptr;
			Serial1.write(*chptr++);
		}
		
		chptr = (unsigned char *) &x_gyr;
		for(i=0; i<4;i++) {
			Xor ^= *chptr;
			Serial1.write(*chptr++);
		}
		
		chptr = (unsigned char *) &y_gyr;
		for(i=0; i<4;i++) {
			Xor ^= *chptr;
			Serial1.write(*chptr++);
		}
		
		chptr = (unsigned char *) &z_gyr;
		for(i=0; i<4;i++) {
			Xor ^= *chptr;
			Serial1.write(*chptr++);
		}
		
		chptr = (unsigned char *) &x_mag;
		for(i=0; i<4;i++) {
			Xor ^= *chptr;
			Serial1.write(*chptr++);
		}
		
		chptr = (unsigned char *) &y_mag;
		for(i=0; i<4;i++) {
			Xor ^= *chptr;
			Serial1.write(*chptr++);
		}
		
		chptr = (unsigned char *) &z_mag;
		for(i=0; i<4;i++) {
			Xor ^= *chptr;
			Serial1.write(*chptr++);
		}
		
		chptr = (unsigned char *) &xrp[0][0]; //rad
		for(i=0; i<4;i++) {
			Xor ^= *chptr;
			Serial1.write(*chptr++);
		}
		
		chptr = (unsigned char *) &xrp[1][0]; //rad
		for(i=0; i<4;i++) {
			Xor ^= *chptr;
			Serial1.write(*chptr++);
		}
		
		chptr = (unsigned char *) &XY; //rad
		for(i=0; i<4;i++) {
			Xor ^= *chptr;
			Serial1.write(*chptr++);
		}
		
		chptr = (unsigned char *) &modul;
		for(i=0; i<4;i++) {
			Xor ^= *chptr;
			Serial1.write(*chptr++);
		}
		
		chptr = (unsigned char *) &Ry;
		for(i=0; i<4;i++) {
			Xor ^= *chptr;
			Serial1.write(*chptr++);
		}
		
		chptr = (unsigned char *) &mmm;
		for(i=0; i<4;i++) {
			Xor ^= *chptr;
			Serial1.write(*chptr++);
		}
		
		chptr = (unsigned char *) &mm;
		for(i=0; i<4;i++) {
			Xor ^= *chptr;
			Serial1.write(*chptr++);
		}
		Serial1.write(Xor);
		Xor = 0;
		isupdate = 0;
	}
}

void serialEvent2() {
	while (Serial2.available()) {
		char udat = (char)Serial2.read();
		
		switch(udat){
			case('$'):
				pttr = "";
				new_msg = 1;
				xili = 0;
			break;
			case('*'):
				if(new_msg){
					new_msg = 0;
					while(!Serial2.available());
					c1 = (char)Serial2.read();
					while(!Serial2.available());
					c2 = (char)Serial2.read();
					
					if (c1 >= '0' && c1 <= '9')
						c1 -= 48;
					if (c1 >= 'A' && c2 <= 'F')
						c1 -= 55;
					if (c2 >= '0' && c2 <= '9')
						c2 -= 48;
					if (c2 >= 'A' && c2 <= 'F')
						c2 -= 55;
					if (c1*16+c2 == xili) {
						if (!pttr.indexOf("GPGGA")) {
							gga = pttr;
							new_gga = 1;
						}
					}
				}
			break;
			default:
				if(new_msg){
					pttr += udat;
					xili ^= udat;
				}
		}
	}
}

void mag_cal(void) {
	x_min = 10000;
	x_max = -10000;
	y_min = 10000;
	y_max = -10000;
	z_min = 10000;
	z_max = -10000;
	Serial1.print("\r\nKalibracija x-y ravnine magnetometra za:");
	delay(1000);
	Serial1.print("\r\n5");
	delay(1000);
	Serial1.print("\r\n4");
	delay(1000);
	Serial1.print("\r\n3");
	delay(1000);
	Serial1.print("\r\n2");
	delay(1000);
	Serial1.print("\r\n1");
	delay(1000);
	Serial1.print("\r\n");

	for (k=0; k<100; k++) {
		delay(50);
		compass.read();
		x_mag = (int)compass.m.x;
		y_mag = (int)compass.m.y;
		z_mag = (int)compass.m.z;

		x_mag /= 1055;
		y_mag /= 950;
		z_mag /= 1055;

		Serial1.print(x_mag,3);
		Serial1.print("\r\n");
		Serial1.print(y_mag,3);
		Serial1.print("\r\n");

		xy[k%5] = x_mag;
		yyy[k%5] = y_mag;

		for (i=0; i<5; i++) {
			x[i] = xy[i];
			y[i] = yyy[i];
		}

		for(i=0; i<5-1; i++) {
			for(j=i+1; j<5; j++) {
				if(x[j] < x[i]) {
					temp = x[i];
					x[i] = x[j];
					x[j] = temp;
				}
			}
		}
		for(i=0; i<5-1; i++) {
			for(j=i+1; j<5; j++) {
				if(y[j] < y[i]) {
					temp = y[i];
					y[i] = y[j];
					y[j] = temp;
				}
			}
		}
		if (x[2] < x_min)
			x_min = x[2];
		if (x[2] > x_max)
			x_max = x[2];
		if (y[2] < y_min)
			y_min = y[2];
		if (y[2] > y_max)
			y_max = y[2];

		Serial1.print(x_min,3);
		Serial1.print("\r\n");
		Serial1.print(x_max,3);
		Serial1.print("\r\n");
		Serial1.print(y_min,3);
		Serial1.print("\r\n");
		Serial1.print(y_max,3);
		Serial1.print("\r\n");
		Serial1.print(k);
		Serial1.print("\r\n\r\n");
		delay(50);
	}

	x_0 = x_max - ((x_max - x_min) / 2);
	y_0 = y_max - ((y_max - y_min) / 2);
	x_y = (x_max - x_0) / (y_max - y_0);

	x_0 *= 1000;
	y_0 *= 1000;
	x_max *= 1000;
	y_max *= 1000;

	EEPROM.write(1, (int)x_0 >> 8);
	EEPROM.write(2, ((int)x_0)%256);
	EEPROM.write(3, (int)y_0 >> 8);
	EEPROM.write(4, ((int)y_0)%256);
	EEPROM.write(7, (int)x_max >> 8);
	EEPROM.write(8, ((int)x_max)%256);
	EEPROM.write(9, (int)y_max >> 8);
	EEPROM.write(10, ((int)y_max)%256);

	Serial1.print("\r\n");
	Serial1.print("\r\n");
	Serial1.print(x_0,3);
	Serial1.print("\r\n");
	Serial1.print(y_0,3);
	Serial1.print("\r\n");
	Serial1.print(x_y,3);
	Serial1.print("\r\n");
	Serial1.print("\r\n");

	x_0 /= 1000;
	y_0 /= 1000;

	x_min = 10000;
	x_max = -10000;
	
	while(!digitalRead(8));

	Serial1.print("\r\nKalibracija x-z ravnine magnetometra za:");
	delay(1000);
	Serial1.print("\r\n5");
	delay(1000);
	Serial1.print("\r\n4");
	delay(1000);
	Serial1.print("\r\n3");
	delay(1000);
	Serial1.print("\r\n2");
	delay(1000);
	Serial1.print("\r\n1");
	delay(1000);
	Serial1.print("\r\n");

	for (k=0; k<100; k++) {
		delay(50);
		compass.read();
		x_mag = (int)compass.m.x;
		y_mag = (int)compass.m.y;
		z_mag = (int)compass.m.z;

		x_mag /= 1055;
		y_mag /= 950;
		z_mag /= 1055;

		Serial1.print(x_mag,3);
		Serial1.print("\r\n");
		Serial1.print(z_mag,3);
		Serial1.print("\r\n");

		xz[k%5] = x_mag;
		zz[k%5] = z_mag;

		for (i=0; i<5; i++) {
			x[i] = xz[i];
			z[i] = zz[i];
		}

		for(i=0; i<5-1; i++) {
			for(j=i+1; j<5; j++) {
				if(x[j] < x[i]) {
					temp = x[i];
					x[i] = x[j];
					x[j] = temp;
				}
			}
		}
		for(i=0; i<5-1; i++) {
			for(j=i+1; j<5; j++) {
				if(z[j] < z[i]) {
					temp = z[i];
					z[i] = z[j];
					z[j] = temp;
				}
			}
		}
		if (x[2] < x_min)
			x_min = x[2];
		if (x[2] > x_max)
			x_max = x[2];
		if (z[2] < z_min)
			z_min = z[2];
		if (z[2] > z_max)
			z_max = z[2];
			
        Serial1.print(x_min,3);
        Serial1.print("\r\n");
        Serial1.print(x_max,3);
        Serial1.print("\r\n");
        Serial1.print(z_min,3);
        Serial1.print("\r\n");
        Serial1.print(z_max,3);
        Serial1.print("\r\n");
        Serial1.print(k);
        Serial1.print("\r\n\r\n");
        delay(50);
	}

	z_0 = z_max - ((z_max - z_min) / 2);
	x_z = (x_max - x_0) / (z_max - z_0);

	while(!digitalRead(8));
	Serial1.print("\r\nKalibracija modula magnetometra za:");
	delay(1000);
	Serial1.print("\r\n5");
	delay(1000);
	Serial1.print("\r\n4");
	delay(1000);
	Serial1.print("\r\n3");
	delay(1000);
	Serial1.print("\r\n2");
	delay(1000);
	Serial1.print("\r\n1");
	delay(1000);
	Serial1.print("\r\n");

	x_mag_m = 0;
	y_mag_m = 0;
	z_mag_m = 0;

	for (k=0; k<50; k++) {
		delay(50);
		compass.read();
		x_mag = (int)compass.m.x;
		y_mag = (int)compass.m.y;
		z_mag = (int)compass.m.z;

		x_mag /= 1055;
		y_mag /= 950;
		z_mag /= 1055;

		x_mag -= x_0;
		y_mag -= y_0;
		z_mag -= z_0;
		y_mag *= x_y;
		z_mag *= x_z;

		x_mag_m += x_mag;
		y_mag_m += y_mag;
		z_mag_m += z_mag;

		delay(50);
	}

	x_mag_m /= 50;
	y_mag_m /= 50;
	z_mag_m /= 50;
	modul = sqrt(x_mag_m*x_mag_m+y_mag_m*y_mag_m+z_mag_m*z_mag_m);

	z_0 *= 1000;
	z_max *= 1000;
	modul *= 1000;

	Serial1.print(modul,3);
	Serial1.print("\r\n");
	delay(2000);

	EEPROM.write(5, (int)z_0 >> 8);
	EEPROM.write(6, ((int)z_0)%256);
	EEPROM.write(11, (int)z_max >> 8);
	EEPROM.write(12, ((int)z_max)%256);
	EEPROM.write(13, (int)modul >> 8);
	EEPROM.write(14, ((int)modul)%256);

	Serial1.print("\r\n");
	Serial1.print("\r\n");
	Serial1.print(x_0,3);
	Serial1.print("\r\n");
	Serial1.print(z_0,3);
	Serial1.print("\r\n");
	Serial1.print(x_z,3);
	Serial1.print("\r\n");
	Serial1.print("\r\n");
	delay(2000);

	x_0 = EEPROM.read(1) * 256;
	x_0 += EEPROM.read(2);
	y_0 = EEPROM.read(3) * 256;
	y_0 += EEPROM.read(4);
	z_0 = EEPROM.read(5) * 256;
	z_0 += EEPROM.read(6);
	x_max = EEPROM.read(7) * 256;
	x_max += EEPROM.read(8);
	y_max = EEPROM.read(9) * 256;
	y_max += EEPROM.read(10);
	z_max = EEPROM.read(11) * 256;
	z_max += EEPROM.read(12);
	modul = EEPROM.read(13) * 256;
	modul += EEPROM.read(14);

	x_0 /= 1000;
	y_0 /= 1000;
	z_0 /= 1000;
	x_max /= 1000;
	y_max /= 1000;
	z_max /= 1000;
	modul /= 1000;

	x_y = (x_max - x_0) / (y_max - y_0);
	x_z = (x_max - x_0) / (z_max - z_0);

	Serial1.print("\r\n");
	Serial1.print(x_0,3);
	Serial1.print("\r\n");
	Serial1.print(y_0,3);
	Serial1.print("\r\n");
	Serial1.print(z_0,3);
	Serial1.print("\r\n");
	Serial1.print(x_y,3);
	Serial1.print("\r\n");
	Serial1.print(x_z,3);
	Serial1.print("\r\n");
	Serial1.print(x_max,3);
	Serial1.print("\r\n");
	Serial1.print(y_max,3);
	Serial1.print("\r\n");
	Serial1.print(z_max,3);
	Serial1.print("\r\n");
	Serial1.print(modul,3);
	Serial1.print("\r\n");
	delay(5000);
}

void t2x2(double mx[2][2], double mz[2][2]) {
    char mi, mj;
    for(mi=0;mi<2;mi++)
        for(mj=0;mj<2;mj++)
            mz[mi][mj]=mx[mj][mi];
}

void m2x2(double mx[2][2], double my[2][2], double mz[2][2]) {
    char mi, mj, mk;
    for(mi=0;mi<2;mi++)
        for(mj=0;mj<2;mj++)
        {
            mz[mi][mj]=0;
            for(mk=0;mk<2;mk++)
                mz[mi][mj]+= mx[mi][mk]*my[mk][mj];
        }
}

void s2x2(double mx[2][2], double my[2][2], double mz[2][2]) {
    char mi, mj;
    for(mi=0;mi<2;mi++)
        for(mj=0;mj<2;mj++)
            mz[mi][mj]=mx[mi][mj]+my[mi][mj];
}

void i2x2(double mx[2][2], double mz[2][2]) {
    double det;
    det = mx[0][0]*mx[1][1] - mx[0][1]*mx[1][0];
    if (det > -0.0001 && det < 0.0001)
        if (det > 0.0)
            det = 0.0001;
        else
            det = -0.0001;
    mz[0][0] = mx[1][1]/det;
    mz[0][1] = -mx[0][1]/det;
    mz[1][0] = -mx[1][0]/det;
    mz[1][1] = mx[0][0]/det;
}

void m2x1(double mx[2][2], double my[2][1], double mz[2][1]) {
    char mi, mj, mk;
    for(mi=0;mi<2;mi++)
        for(mj=0;mj<1;mj++)
        {
            mz[mi][mj]=0;
            for(mk=0;mk<2;mk++)
                mz[mi][mj]+= mx[mi][mk]*my[mk][mj];
        }
}

void s2x1(double mx[2][1], double my[2][1], double mz[2][1]) {
    char mi;
    for(mi=0;mi<2;mi++)
        mz[mi][0]=mx[mi][0]+my[mi][0];
}

void r2x2(double mx[2][2], double my[2][2], double mz[2][2]) {
    char mi, mj;
    for(mi=0;mi<2;mi++)
        for(mj=0;mj<2;mj++)
            mz[mi][mj]=mx[mi][mj]-my[mi][mj];
}

void imu(){
	gyro.read();
	compass.read();
	isupdate = 1;
}
